/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	memorymanagement.h
	Handles memory for the x86 architecture.

******************************************************************************/

#ifndef SORTIX_MEMORYMANAGEMENT_H
#define SORTIX_MEMORYMANAGEMENT_H

namespace Sortix
{
	namespace Page
	{
#ifdef MULTIBOOT_HEADER
		void	Init(multiboot_info_t* BootInfo);
#endif
		void*	Get();
		void	Put(void* Page);
		void	GetNoCache();
		void	PutNoCache(void* Page);
	}

#if 1
	namespace VirtualMemory
	{
		struct Table
		{
			uintptr_t Page[4096 / sizeof(uintptr_t)];
		};

		struct Dir
		{
			uintptr_t Table[4096 / sizeof(uintptr_t*)];
		};

		void	Init();
		void	SwitchDir(Dir* PhysicalDirAddr);
		void	Map(uintptr_t Physical, uintptr_t Virtual, uintptr_t Flags);
		void	MapUnsafe(uintptr_t Physical, uintptr_t Virtual, uintptr_t Flags);
		void	Flush();
		void	Fixup(Dir* Dir);
		Dir*	NewDir();
	}
#endif
	
#if 0
		class VirtualMemory
		{
		private:
			size_t KernelLeadingPages;
			Dir* CurrentDirPhys;
			Dir* KernelDirPhys;
			bool Virgin;

		public:
			void Init();

		// These are used internally to manage the virtual memory in physical mode during boot.
		private:
			Table* GetTablePhys(uintptr_t Addr);
			void IdentityPhys(uintptr_t Addr);
			void FixupPhys(Dir* Dir);

		public:
			void SwitchDir(Dir* PhysicalDirAddr);
			void Map(uintptr_t Physical, uintptr_t Virtual, uintptr_t Flags);
			void MapUnsafe(uintptr_t Physical, uintptr_t Virtual, uintptr_t Flags);
			void Flush();
			void Fixup(Dir* Dir);
			Dir* NewDir();

		};
#endif
}

#endif

